// Odhad denního průběhu intenzity s modelem
// - absolutním
// - přírůstkovým
// - odchylkovým
// ----------------------------------------------------------
exec SCIHOME/ScIntro.sce, mode(0)

// simulace
nd=1000;
s=min([sin(%pi*(1:nd)/nd);.7*ones(1,nd)],'r')*10;
y=s+.1*rand(1,nd,'n');
u=zeros(1,nd);

// odhad
V1=[]; V2=[]; V3=[]; ka=0;
for t=3:nd
  Ps=[y(t) y(t-1) y(t-2) u(t) 1];                 // abs.
  V1=V1+Ps'*Ps;
  
  Ps=[y(t)-y(t-1) y(t-1)-y(t-2) y(t-2) u(t)];     // přír.
  V2=V2+Ps'*Ps;
  
  Ps=[y(t)-s(t) y(t-1)-s(t-1) u(t) 1];            // odch.
  V3=V3+Ps'*Ps;

  ka=ka+1;
end
th1=v2thN(V1/ka,1)
th2=v2thN(V2/ka,1)
th3=v2thN(V3/ka,1)

// predikce
y2(2)=0;
for t=3:nd
  ps=[y(t-1) y(t-2) u(t) 1];                      // abs.
  y1(t)=ps*th1;
  e1(t)=y(t)-y1(t);
  
  ps=[y(t-1)-y(t-2) y(t-2) u(t)];                 // přír.
  yp=ps*th2;
  y2(t)=yp+y(t-1);
  e2(t)=y(t)-y2(t);
  
  ps=[y(t-1)-s(t-1) u(t) 1];                      // odch.
  yp=ps*th3;
  y3(t)=s(t)+yp;
  e3(t)=y(t)-y3(t);
end

set(scf(1),'position',[600 100 600 500])
plot(y)

// chyby predikce
E1=sumsq(e1)
E2=sumsq(e2)
E3=sumsq(e3)
