// P32PreCat1.sce
// Prediction one-step ahead with scalar categorical model 
// - model is binary + memmory + control   f(z(t)|u(t),z(t-1))
// -----------------------------------------------------------
[u,t,n]=file();                         // find working directory
chdir(dirname(n(2)));                   // set working directory
clear("u","t","n")                      // clear auxiliary data
exec("ScIntro.sce",-1),mode(0)          // intro to sesion                 

load _data/dataT12.dat Sim         // results from task T12SimCat.sce
zt=Sim.Cz.zt;                      //   the data zt, ut 
ut=Sim.Cz.ut;                      //   and parameters th are 
th=Sim.Cz.th;                      //   extracted from simulation
load _data/dataT22.dat Est         // results from estimation are taken
thE=Est.Cz.th;                     //   from task T22EstCat.sce


nd=min(50,length(zt));             // number of data (minimum is 50)
yp=ones(1,nd);
for t=2:nd                         // time loop
  j=psi2row([ut(t),zt(t-1)],[2,2]);               // row in the table
  yp(t)=sum(rand(1,1,'u')>cumsum(thE(j,:)))+1;    // prediction at t
end
Pre.Cz.np=1;                       // only 1 step prediction
Pre.Cz.yp=yp;

// Results
s=1:nd;
printf('There is %d wrong predictions from %d\n',sum(zt(s)~=yp(s)),length(s))

plot(s,zt(s),'b:o',s,yp(s),'r:.')
legend('output','prediction');
title 'Output and its prediction'

save _data/dataT32.dat Sim Est Pre
