// Classification with mixture model already estimated (trained)
// - estimation is performed in T72 
[u,t,n]=file();                         // find working directory
chdir(dirname(n(2)));                   // set working directory
clear("u","t","n")                      // clear auxiliary data
exec("ScIntro.sce",-1),mode(0)          // intro to sesion                 

nd=500;                  // number of data

load _data/dataT72.dat Est Sim     // DATA FOR CLASSIFICATION

load _data/dataKF.dat;             // RESULTS OF ESTIMATION
// THIS IS FOR DATA FROM SKODA
  dt=DataKF.dataOrig;
  T=100;
  cc=dt(6,:);                      // gear (classes)
  c5=zeros(1,length(cc));
  j=find((cc==-1)|(cc==0)); c5(j)=1;
  j=find((cc>.5)&(cc<3.5)); c5(j)=2;
  j=find(cc==4); c5(j)=3;
  j=find(cc==5); c5(j)=4;
  j=find(cc==6); c5(j)=5;

  ct=c5(1:T:$);
  yt=[dt(2,1:T:$);                 // speed
  dt(4,1:T:$);                     // gas
  dt(7,1:T:$);                     // moment
  dt(8,1:T:$)/1000];               // revs (in thousands)
// ---------------------------------

nc=Sim.nc;                         // no.of components (from estimation)
my=size(yt,1);                     // dim. of output
Cla.Cp.V=ones(1,nc);               // initial pointer statistics
Cla.Cp.th=fnorm(rand(1,nc,'u')+1); // initial parmeters
w=fnorm(ones(1,nc));               // initial weights

// ESTIMATION
printf(' '), tt=fix(nd/10); 
for t=(2:nd)        // TIME LOOP = = = = = = = = = = = = = = = = = = = =
  if t/tt==fix(t/tt), printf('.'); end
  for j=1:nc
    [xxx,G(j)]=GaussN(yt(:,t),Est.Cy(j).th,Est.Cy(j).cv); // likelihoods
  end
  Lq=G-max(G);
  q=exp(Lq);

  ww=q'.*Cla.Cp.th; w=ww/sum(ww);   // weighting vector w
  wt(:,t)=w';
  //update stat for nu 
  Cla.Cp.V=Cla.Cp.V+w;              // pointer statistics
  Cla.Cp.th=Cla.Cp.V/sum(Cla.Cp.V); // pt.est. of pointer parametr

  [ss,ce(t)]=max(w);                // store pt.
end                 // END of time loop = = = = = = = = = = = = = = = =
Cla.Cp.yt=ce;

// RESULTS
s=1:length(ce);
set(scf(2),'position',[500 100 800 600])
plot(Cla.Cp.yt(s),':x')
plot(Sim.Cp.yt(s),'r:.','markersize',5)
title 'Class point estimates'

PE=sum(Sim.Cp.yt(s)~=Cla.Cp.yt')/length(s)*100;
printf('\n Wrong classifications: %5.2f percent\n',PE)
