function [Eh,Ed]=MEst78(y,d,Eh,Ed)
  // estimation of both upper and lower mixture
  // upper: 3 norm. components
  // lower: 2 comp. - first half-normal
  //                - second exponential

  nc=Eh.nc;
  al=Eh.Cp.th;
  Wh=Eh.w;
  ny=length(d);

  wd=list();
  v=list();
  // PROXIMITIES AND WEIGHTS
  for i=1:nc
    // PROXIMITY UPPER
    [xxx,Gh(i)]=GaussN(y,Eh.Cy(i).th,Eh.Cy(i).sd); // Gauss
    // PROXIMITY LOWER
    [xxx,Gd(1)]=HnormN(d,Ed(i).Cy(1).th)          // (th is "s"; E=.8*s)
    [xxx,Gd(2)]=ExpN(d,Ed(i).Cy(2).th);           // (th is expectation)
    Ld=Gd-max(Gd);
    q(i,:)=fnorm(exp(Ld))';                       // proximity lower

    wd(i)=Ed(i).w;
    be(i,:)=Ed(i).Cp.th;
  end
  Lh=Gh-max(Gh); 
  p=fnorm(exp(Lh))';                              // proximity upper
  
  W=fnorm((Wh'*p).*al);                           // joint pf of c_t and c_t-1
  Wh=sum(W,1);                                    // uppwer weight
  [xxx,ch]=max(Wh);
  Eh.w=Wh;

  Wd=fnorm((Wh'*ones(1,2)).*(q.*be));             // lower weight
  for i=1:Eh.nc
    Ed(i).w=Wd(i,:);
  end // ---------------------------------------- end of proximity

  // UPDATE OF COMPONENTS AND COMPUTATION OF POINT ESTIMATES 
  // UPPER mixture
  Ps=[y';1];                                      // Regression vekcor
  for i=1:Eh.nc
    Eh.Cy(i).V=Eh.Cy(i).V+Wh(i)*Ps*Ps';           // information matrix
    Eh.ka(i)=Eh.ka(i)+Wh(i);                      // counter

    // point estimates of upper parameters
    // for scalar y !!!
    Vy=Eh.Cy(i).V(1,1);                           // Vyp  - y.y
    Vyp=Eh.Cy(i).V($,1);                          // Vyp - psi.y
    Vp=Eh.Cy(i).V($,$);                           // Vp  - psi.psi'
    Eh.Cy(i).th=inv(Vp+1e-8*eye(Vp))*Vyp;         // estimate of reg. coef.
    Eh.Cy(i).tht(:,t)=Eh.Cy(i).th';
    if 0                                          // estimate of covariance
      Eh.Cy(i).cv=(Vy-Vyp'*inv(Vp+1e-8*eye(Vp))*Vyp)/Eh.ka(i); 
    end
  end
  Eh.Cp.V=Eh.Cp.V+W;                              // pointer statistics
  Eh.Cp.th=fnorm(Eh.Cp.V,2);                      // estimate of pt. parameters

  // LOWER mixture 
  // update of statistics for hnm
  for i=1:Eh.nc
    Ed(i).Cy(1).V=Ed(i).Cy(1).V+wd(i)(1)*d^2;     // stat. = sum of squares
    Ed(i).ka(1)=Ed(i).ka(1)+wd(i)(1);             // counter
    // point estimates of parameters for hnm
    Ed(i).Cy(1).th=sqrt(Ed(i).Cy(1).V/Ed(i).ka(1));

    // update of statistics for exp     
    Ed(i).Cy(2).V=Ed(i).Cy(2).V+wd(i)(2)*d;       // stat. = sum
    Ed(i).ka(2)=Ed(i).ka(2)+wd(i)(2);             // counter
    // point estimates of parameters for exp
    Ed(i).Cy(2).th=Ed(i).Cy(2).V/Ed(i).ka(2);

    Ed(i).Cp.V=Ed(i).Cp.V+wd(i);                  // pointer statistics
    Ed(i).Cp.th=fnorm(Ed(i).Cp.V,2);              // pointer parameters
  end
endfunction

