﻿// ini3Hold.sce
// Přidržení apriorních parametrů
// ------------------------------------------
[u,t,n]=file();                         // find working directory
chdir(dirname(n(2)));                   // set working directory
clear("u","t","n")                      // clear auxiliary data
exec("ScIntro.sce",-1),mode(0)          // intro to sesion

nd=200;             // number of data for estimation
ni=1;               // number of initial data  ni>0

b0=1; a1=.3; b1=-.2; k=1.5; sd=1; y(1)=-2;   // sim. parameters
B0=2; A1=.1; B1=.2; K=-1;                    // ini. est. parameters

u=sin(8*%pi*(1:nd)/nd)+rand(1,nd,'n');       // control
// Simulation
for t=2:nd
  y(t)=b0*u(t)+a1*y(t-1)+b1*u(t-1)+k+sd*rand(1,1,'n');
end

// Initialization
V=[1 B0 A1 B1 k                              // information matrix
  b0 1  0  0  0
  A1 0  1  0  0
  B1 0  0  1  0
  K  0  0  0  1];

V=V*ni;        // Inf. matrix is set to give initial parameters, ni sais
               //   as if how many initial data items have been used.

// Estimation
for t=2:nd
  Ps=[y(t) u(t) y(t-1) u(t-1) 1]';
  V=V+Ps*Ps';
  Vy=V(1:2,1);
  Vyp=V(2:$,1);
  Vp=V(2:$,2:$);
  th=inv(Vp+1e-12*eye(Vp))*Vyp;
  tht(:,t)=th';                              // evolution of estimates
end

// Results
s=nd-50:nd;
tx=['b';'r';'k';'m';'c';'g'];
scf();
for i=1:size(tht,1)
  plot(tht(i,2:$),tx(i))
end
plot(s,ones(s)*b0,':'+tx(1))
plot(s,ones(s)*a1,':'+tx(2))
plot(s,ones(s)*b1,':'+tx(3))
plot(s,ones(s)*k,':'+tx(4))
title 'Evolution of estimated parameters and theit true values'
