function [R,S]=DynProg(M,N,R,Om)
  // dynamic programming - one step of iterations
  // M,N  state-space model matrices
  // R    criterion remainder
  // Om   extended penalization
  // S    control law
  
  T=R+Om;
  A=N'*T*N;
  B=N'*T*M;
  C=M'*T*M;
  S=inv(A)*B;
  R=C-S'*A*S;
endfunction
