function [p,T]=c2c(c1,c2)                                          
  // cc=c2c(c2,c1)   permutation of pointer values
  // c1      simulated pointer
  // c2      estimated pointer
  // p       transformation vector
  // T       transf. matrix
  //
  // USSAGE:
  // set:  [q T]=c2c(c_sim,c_est);   simul., estim
  // plot(1:nd,c_sim,1:nd,q(c_est))  c_sim, q(c_est) 
  //                                 true,  transformed estim.


  m=max(c1);                       // number of components
  T=1e-5*ones(m,m);
  n=min(length(c2),length(c1));   // common area for sim.
  // and estimation 
  for i=1:n
    j=min(c1(i),m);
    T(c2(i),j)=T(c2(i),j)+1;       // transf. matrix
  end
  T=fnorm(T,2);                   // normalization of T
  Q=fnorm(inv(T+1e-8*eye(T)),2);

  // computation of transformation vector
  //    p(sim) <-> est ...>  plot(p(sim),est) is OK
  p=[];
  for i=1:m
    [xxx,mx]=max(T(i,:));
    p=[p mx];
  end
  
  //    sim <-> q(est) ...>  plot(sim,q(est)) is OK
  q=[];
  for i=1:m
    [xxx,mx]=max(Q(i,:));
    q=[q mx];
  end

  // Check no cluster is caught by more than one comoonent
  for i=1:n
    ii=sum(i==p);
    if ii>1
      disp('*** Components are overlapping ***')
    end
  end
endfunction
