function [M,N,A,nx,ny,nu]=reg2st2(theta,n)
  // [M,N,A,nx,ny,nu,n]=reg2st(theta) conversion of reg.model to state-sp. one
  // M,N,A   parameters of state model    x(t)=Mx(t-1)+Nu(t),  y(t)=Ax(t)
  // nx      length of the state
  // ny,nu   number of outputs and inputs
  // theta   reg.mod. parametrs - b0 a1 b1 .. an bn k  (full str.)
  // n       model order

  [ny nt]=size(theta);
  nu=(nt-n*ny-1)/(n+1);
  nx=n*(ny+nu)+1;

  if fix(nu)~=nu, disp(' Wrong theta'), end

  // parameters of:   x(t)=Mx(t-1)+Nu(t),  y(t)=Ax(t)
  n1=(n-1)*ny;
  n2=(n-1)*nu;
  m1=theta(:,[1:n1 (n1+nu+1):nt]);    
  m2=[eye(n1,n1) zeros(n1,nt-nu-n1)];
  m3=zeros(nu,nt-nu);
  m4=[zeros(n2,n1+ny) eye(n2,n2) zeros(n2,nu+1)];
  m5=[zeros(1,nt-nu-1) 1]
  M=[m1;m2;m3;m4;m5];
  N=[theta(:,(n1+1):(n1+nu));zeros((n-1)*ny,nu);eye(nu,nu);zeros((n-1)*nu+1,nu)];
  A=[eye(ny,ny) zeros(ny,nt-ny-nu)];
endfunction
